unit Custsx;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, Tqryqbe, StdCtrls, Mask, DBCtrls, Tdbedqbe,
  Grids, DBGrids, Tedqbe, ExtCtrls, Trngqbe, Tcombqbe, Tchkqbe, Tfldqbe;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    QueryQBE1: TQueryQBE;
    QueryQBE1CustNo: TFloatField;
    QueryQBE1Company: TStringField;
    QueryQBE1Addr1: TStringField;
    QueryQBE1Addr2: TStringField;
    QueryQBE1City: TStringField;
    QueryQBE1State: TStringField;
    QueryQBE1Zip: TStringField;
    QueryQBE1Country: TStringField;
    QueryQBE1Phone: TStringField;
    QueryQBE1FAX: TStringField;
    QueryQBE1TaxRate: TFloatField;
    QueryQBE1Contact: TStringField;
    QueryQBE1LastInvoiceDate: TDateTimeField;
    Button1: TButton;
    DBGrid1: TDBGrid;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditQBE2: TEditQBE;
    EditQBE1: TEditQBE;
    cboCity: TComboQBE;
    GroupBox2: TGroupBox;
    RangeQBE1: TRangeQBE;
    CheckQBE1: TCheckQBE;
    Button2: TButton;
    cboFields: TFieldListQBE;
    QueryQBE1Company_sx: TStringField;
    QueryQBE1City_sx: TStringField;
    QueryQBE1Contact_sx: TStringField;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query1Company: TStringField;
    Query1City: TStringField;
    Query1State: TStringField;
    Query1Country: TStringField;
    Query1Contact: TStringField;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure FieldSelected(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ActiveLabel: TLabel;
  sGridSQL:    TStringList;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  QueryQBE1.ExecQBE;

  { Assign SQL statement from QBE Query to grid Query
    and execute it }
  Query1.Close;
  Query1.SQL.Clear;
  Query1.SQL.Assign(sGridSQL);
  if QueryQBE1.WhereClause.Count > 0 then begin
    Query1.SQL.Add(' WHERE (');
    Query1.SQL.AddStrings(QueryQBE1.WhereClause);
    Query1.SQL.Add(') ');
  end;
  Query1.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cboCity.Items.Add('Nassau');
  cboCity.Items.Add('Honolulu');

  { Back up original SQL statement from grid query
    so we can resore it when needed }

  sGridSQL := TStringList.Create;
  sGridSQL.Clear;
  sGridSQL.AddStrings(Query1.SQL);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  QueryQBE1.Clear;

  { Assign SQL statement from QBE Query to grid Query
    and execute it }
  Query1.Close;
  Query1.SQL.Clear;
  Query1.SQL.Assign(sGridSQL);
  if QueryQBE1.WhereClause.Count > 0 then begin
    Query1.SQL.Add(' WHERE (');
    Query1.SQL.AddStrings(QueryQBE1.WhereClause);
    Query1.SQL.Add(') ');
  end;
  Query1.Open;

end;

procedure TForm1.Label1Click(Sender: TObject);
var
  i: Integer;
begin
  { Remember active label }
  ActiveLabel := (Sender as TLabel);

  { position combo }
  cboFields.Left := ActiveLabel.Left - 2;
  cboFields.Top := ActiveLabel.Top - 2;

  { try to find list entry with active combo text }
  for i := 0 to cboFields.Items.Count -1 do begin
    if cboFields.Items[i] = ActiveLabel.Caption then begin
      cboFields.ItemIndex := i;
      cboFields.Visible := True;
      cboFields.SetFocus;
      Exit;
    end;
  end;

  cboFields.Visible := True;
  cboFields.SetFocus;
end;

procedure TForm1.FieldSelected(Sender: TObject);
begin
  cboFields.Visible := False;
  ActiveLabel.Caption := cboFields.Text;
  Case ActiveLabel.Tag of
    1:
    begin
      EditQBE1.DataField   := cboFields.FieldName;
      EditQBE1.Text := '';
    end;
    2:
    begin
      EditQBE2.DataField   := cboFields.FieldName;
      EditQBE2.Text := '';
    end;
    3:
    begin
      cboCity.DataField := cboFields.FieldName;
      cboCity.Text := '';
    end;
  end;
end;

end.
